Game = {}

function Game:init()
end

function Game:enter()
	require "maps/arena"
	lg = love.graphics
	tile = lg.newImage("graphics/tileset.png")
	bf = lg.newQuad(0, 0, 64, 64, tile:getDimensions())
	pf = lg.newQuad(64, 0, 64, 64, tile:getDimensions())
	bw = lg.newQuad(0, 64, 64, 64, tile:getDimensions())
	pw = lg.newQuad(64, 64, 64, 64, tile:getDimensions())
	playeri = lg.newImage("graphics/tempplayer.png")
	tiles = {}
	world = Bump.newWorld()
	TILE_W, TILE_H = 64,64
	player = {x=200,y=200}
	world:add(player,player.x,player.y,32,32)
	camera = Camera(0,0)
end

function Game:leave()
end

function Game:update(dt)
	local goalX, goalY = player.x,player.y

	if love.keyboard.isDown("w") then
		goalY = goalY - 200 * dt
	end
	if love.keyboard.isDown("a") then
		goalX = goalX - 200 * dt
	end
	if love.keyboard.isDown("s") then
		goalY = goalY + 200 * dt
	end
	if love.keyboard.isDown("d") then
		goalX = goalX + 200 * dt
	end
	
	local actualX,actualY = world:move(player,goalX,goalY)
	player.x,player.y = actualX,actualY
	camera:lookAt(player.x,player.y,0)
end

function createTile(world, image, x, y)
	local tile = {image=image, x=x*TILE_W, y=y*TILE_H}
	tiles[#tiles+1] = tile
	world:add(tile, tile.x, tile.y, TILE_W, TILE_H)
end

function Game:draw()
	camera:attach()
	for my = 0 ,22 do
		for mx = 0 , 39 do
			v = mapdata[my+1][mx+1]
			
			if v == 1 then
				lg.draw(tile,bf,mx*TILE_W,my*TILE_H)
			end
			if v == 2 then
				lg.draw(tile,pf,mx*TILE_W,my*TILE_H)
			end
			if v == 3 then
				lg.draw(tile,bw,mx*TILE_W,my*TILE_H)
				createTile(world, tile, mx, my)				
			end
			if v == 4 then
				lg.draw(tile,pw,mx*TILE_W,my*TILE_H)
				createTile(world, tile, mx, my)
			end
		end
	end
	lg.draw(playeri,player.x,player.y)
	camera:detach()
	love.graphics.print("FPS: "..tostring(love.timer.getFPS( )), 10, 20)
end

return Game

